From dbe7cb0721142651133befcbfa2a33f312fca6ba Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 11 2020 08:20:00 +0000
Subject: [PATCH 615/2232] Merge pull request #197 from dtolnay/find


Find cxx::bridge mod nested inside another mod
---

diff --git a/gen/src/find.rs b/gen/src/find.rs
index dc83431..86e1dc7 100644
--- a/gen/src/find.rs
+++ b/gen/src/find.rs
@@ -4,7 +4,14 @@ use quote::quote;
 use syn::{Attribute, File, Item};
 
 pub(super) fn find_bridge_mod(syntax: File) -> Result<Input> {
-    for item in syntax.items {
+    match scan(syntax.items)? {
+        Some(input) => Ok(input),
+        None => Err(Error::NoBridgeMod),
+    }
+}
+
+fn scan(items: Vec<Item>) -> Result<Option<Input>> {
+    for item in items {
         if let Item::Mod(item) = item {
             for attr in &item.attrs {
                 let path = &attr.path;
@@ -19,12 +26,17 @@ pub(super) fn find_bridge_mod(syntax: File) -> Result<Input> {
                         }
                     };
                     let namespace = parse_args(attr)?;
-                    return Ok(Input { namespace, module });
+                    return Ok(Some(Input { namespace, module }));
+                }
+            }
+            if let Some(module) = item.content {
+                if let Some(input) = scan(module.1)? {
+                    return Ok(Some(input));
                 }
             }
         }
     }
-    Err(Error::NoBridgeMod)
+    Ok(None)
 }
 
 fn parse_args(attr: &Attribute) -> syn::Result<Namespace> {

